uses mpaskon,misxdpp;
const
  npz:tnpz=(1,20,23,35,48,59,64,72,82,92,109,0,0,0,0);
  rpz:trpz=(0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0);
var
  g,t,w,r,p,tw:tr;
  a,b,c,d,f,k,maxdmd,x,Result,tr,r1,r2, sa, sb:real;
  e,i,j,k1,f1,it,di2,di5,code:integer;
  {w: array[1..8] of real;}
  y: array[1..8] of real;
  c1: array[1..6,1..9] of real;
  rr: array[1..2,1..5] of real;
  w1: array[1..6,1..6,1..4] of real;
  d1,d2,d5: string;
  ma, mb: array[1..3, 1..4] of real;
  b1	 : boolean;

function getdig(a : real;i:integer ):integer;
begin
   getdig:=trunc(a*exp(i*ln(10))) mod 10;
end; { getdig }

function get4d(a :real ):integer;
begin
   get4d:=getdig(a,1)+getdig(a,2)+getdig(a,3)+getdig(a,4);
end; { get4d }

begin
  a:=13.4;
  b:=4.82;
  c:=2.1;
  d:=0.35;
  f:=0.5;
  k:=1.0;

  {1}
  x:=sqrt(abs(a+b/c+ln(abs(a+b))+sin(f)+cos(f)));
  rpz[1]:=x;

  {2}
   x:=0;
   isxdpp(10, 8, g);
   isxdpp(15, 8, t);
   for i:=1 to 8 do
   begin
        w[i]:=(g[i]-t[i])*10;
        y[i]:=t[i]+g[i];
        x:=x+w[i]-y[i];
   end;
   rpz[2]:=x;

   {3}
   isxdpp(4, 75, g);
   maxdmd:=0;
   for i:= 1 to 75 do
        if (((g[i] > 0.15) and (g[i] < 0.65)) and (g[i] > maxdmd)) then
           maxdmd:=g[i];
   rpz[3]:=maxdmd;

   {4}
   if a>=b then
       x:=a*(sin(f)+cos(f)+sin(f)/cos(f))
   else
       x:=a*(sin(f)+2*cos(f)-sin(f)/cos(f));
   rpz[4]:=x;

   {5}
   isxdpp(7, 144, tw);
   f1:=1;
   x:=0;
   for i:=1 to 6 do
      for j:=1 to 6 do
          for k1:=1 to 4 do
          begin
                w1[i, j, k1]:= tw[f1];
                if (i=j) and (i=k1) then x:=x+w1[i,j,k1];
                inc(f1);
          end;
   rpz[5]:=x;


   {6}
   isxdpp(5, 6, r);
   isxdpp(11, 9, p);
   for i:=1 to 6 do begin
       for j:=1 to 9 do begin
           if (r[i]>=0.8) and (r[i]<0.6) then c1[i,j]:=ln(r[i]);
           if (r[i]>=0.8) and (r[i]>=0.6) then c1[i,j]:=ln(p[j]);
           if (r[i]<0.8) and (r[i]>=0.4) and (p[j]<0.6) then c1[i,j]:=sin(r[i])/cos(r[i]);
           if (r[i]<0.8) and (r[i]>=0.4) and (p[j]>=0.6) then c1[i,j]:=sin(p[j])/cos(p[j]);
           if (r[i]<0.8) and (r[i]<0.4) and (p[j]<0.6) then c1[i,j]:=sqrt(r[i]);
           if (r[i]<0.8) and (r[i]<0.4) and (p[j]>=0.6) then c1[i,j]:=sqrt(p[j]);
       end;
   end;
   x:=sqrt(c1[1,1]+c1[6,9]);
   rpz[6]:=x;

   {7}
   isxdpp(2, 10, g);
   f1:=1;
   x:=0;
   for i:=1 to 2 do
      for j:=1 to 5 do
          begin
                rr[i, j]:= g[f1];
                inc(f1);
          end;

   e:=0;
   for i:=1 to 2 do
      for j:=1 to 5 do
	 if ((getdig(rr[i,j],5)-getdig(rr[i,j],2))=(i+j)) then
	       e:=e+getdig(rr[i,j],1)+getdig(rr[i,j],2)+getdig(rr[i,j],3);
    rpz[7]:=e;

{
    8.
    ନ஢  (3,4)  =10; NC=21 (den: ⥬, ! =21, NC=12!!!)
    冷     㬬 1-   ஡
    .
    ନ஢  (3,4)  祣  ﬨ  
    㯮冷祭  , 㬬 ᮢ   6   2.
    ᫨ X=SA-SB,  SA  SB - 㬬 ⮢    .
}
   isxdpp(21, 12, g);
   f1:=1;
   for i:=1 to 3 do
       for j:=1 to 4 do
       begin
            ma[i,j]:=g[f1];
            inc(f1);
       end;

   b1:=true;
   while b1 do
   begin
      b1:=false;
      for k1:=1 to 11 do
      begin
	 r1:=ma[((k1-1) div 4) + 1,((k1-1) mod 4) + 1 ];
	 r2:=ma[(k1 div 4) + 1,(k1 mod 4) + 1 ];
         {den: ???  㪠,  ( ⠭   뢠) ஢
           뢠...
         }
	 if get4d(r1)<get4d(r2) then
	 begin
	    ma[((k1-1) div 4) + 1,((k1-1) mod 4) + 1 ]:=r2;
	    ma[(k1 div 4) + 1,(k1 mod 4) + 1 ]:=r1;
	    b1:=true;
	 end;
      end;
   end;

   for i:=1 to 3 do
   begin
       for j:= 1 to 4 do
           write(ma[i, j]:8:4, '(', get4d(ma[i, j]), ') ');
       writeln;
   end;


   sa:=0;sb:=0;
   for i:=1 to 3 do
       for j:= 1 to 4 do
       begin
           if (((i+j) > 2) AND ((i+j) < 6)) then
              mb[i, j]:=0
           else
              mb[i, j]:=ma[i, j];
           sa:=sa+ma[i, j];
           sb:=sb+mb[i, j];
       end;
   x:=sa-sb;
   rpz[8]:=x;

   paskon(npz,rpz);

 end.


