uses strings, time;

const
     Num_in_tokken = 4; {⢮   ᫥ ⮪}
     Num_in_tokken_val = 10000; {10 ^ Num_In_Tokken ( ,      ⥯;)}

     Max_out_chars = 1024;

type
    TTokkenNum = longint;

    {㭠ࠢ ᯨ᮪}
    PBigNumber = ^TBigNumber;
    TBigNumber = record
               tokken_num: TTokkenNum;

               next, prev: PBigNumber;
    end;

function int2str(val: longint): string;
var
   out: string;
begin
   str(val, out);
   int2str:=out;
end;


{
  ஥ ᯨ᪠  訬 ᫮

  IN:
    Number: string  - ᫮
  OUT:
    㪠⥫  砫 ᮧ ᯨ᪠
}
function bnBuild(Number: string): PBigNumber;
var
   bn, bn_s: PBigNumber;
   tokken_s: string[Num_in_tokken];
   tokken_n: TTokkenNum;
   code: integer;
begin
   {᫥ (;) }

   {쬥 Num_in_tokken ᫥   ப}
   tokken_s:=Copy(Number, length(Number)-(Num_in_tokken-1), Num_in_tokken);
   Delete(Number, length(Number)-(Num_in_tokken-1), Num_in_tokken);
   val(tokken_s, tokken_n, code);
   if (code = 0) then begin
      new(bn);
      bn^.next:=nil;
      bn^.prev:=nil;
      bn^.tokken_num:=tokken_n;
      bn_s:=bn;
   end
   else begin
      bnBuild:=nil;
      exit;
   end;

   {ந ᯨ᮪  }
   while(length(Number) > 0) do begin
        tokken_s:=Copy(Number, length(Number)-(Num_in_tokken-1), Num_in_tokken);
        Delete(Number, length(Number)-(Num_in_tokken-1), Num_in_tokken);

        {஡㥬 ॢ 祭 ப  ᫮,
        ᫨  㤠,  ய⨬  ᮪}
        val(tokken_s, tokken_n, code);
        if (code = 0) then begin
           new(bn^.next);
           bn^.next^.prev:=bn;
           bn:=bn^.next;
           bn^.tokken_num:=tokken_n;
           bn^.next:=nil;
        end;
   end;

   bnBuild:=bn_s;
end;

{
  祭 讣 ᫠

  IN:
    BigNumber: PBigNumber  - ᯨ᮪
  OUT:
    ப  ᫮  ଠ ASCII (!!!  !!! ᨬ 255 ᨬ!!! :()
}
function bnGet(BigNumber: PBigNumber): string;
var
   OutStr: string;
   t_str: string[Num_in_tokken];
   i: integer;
   bn_t: PBigNumber;
begin
   OutStr:='';
   bn_t:=BigNumber;
   while(bn_t <> nil) do begin
        str(bn_t^.tokken_num, t_str);
        if (bn_t^.next <> nil) then {᫨   ,  塞 砫 㫨}
            for i:=1 to (Num_in_tokken-length(t_str)) do
              t_str:='0'+t_str;
        OutStr:=t_str+'|'+OutStr;

        bn_t:=bn_t^.next;
   end;
   bn_t:=BigNumber;
   bnGet:=OutStr;
end;


{
  祭 讣 ᫠  襭 ஡ -祭  ᥫ

  IN:
    BigNumber: PBigNumber  - ᯨ᮪
  OUT:
    ப  ᫮  ଠ ASCII !!! Null-terminated !!!
     getmem(Max_out_chars). 室 ⮬ ᢮!
}
function bnGetPChar(BigNumber: PBigNumber): PChar;
var
   OutStr: PChar;
   t_str: string[Num_in_tokken];
   t_str_p: array [0..Num_in_tokken] of char;
   i: integer;
   bn_t: PBigNumber;
begin
   if (BigNumber = nil) then exit;

   GetMem(OutStr, Max_out_chars);

   {( 祭 ⨬쭮) 砫 ன   ᯨ᪠}

   bn_t:=BigNumber;
   while (bn_t^.next <> nil) do bn_t:=bn_t^.next;

   StrCopy(OutStr, '');
   while(bn_t <> nil) do begin
        str(bn_t^.tokken_num, t_str);
        if (bn_t^.next <> nil) then {᫨   ,  塞 砫 㫨}
            for i:=1 to (Num_in_tokken-length(t_str)) do
              t_str:='0'+t_str;

        for i:=1 to length(t_str) do
            t_str_p[i-1]:=t_str[i];
        t_str_p[length(t_str)]:=#0;

        StrCat(OutStr, t_str_p);

        bn_t:=bn_t^.prev;
   end;

   bnGetPChar:=OutStr;
end;

{
  ᯨ᪠  
}
procedure bnDestroy(BigNumber: PBigNumber);
var
   t: PBigNumber;
begin
   while(BigNumber <> nil) do begin
       t:=BigNumber^.next;
       dispose(BigNumber);
       BigNumber:=t;
   end;
end;


{
   2-  ᥫ
}
function bnMull(bn1, bn2: PBigNumber): PBigNumber;
var
   bn1_t, bn_res, bn_res_start, bn_res_end, bn_res_t, bn_t: PBigNumber;
   num1, num_n2, zaem_m, zaem_a: TTokkenNum;
   n1, n2: longint;
begin
   new(bn_res);
   bn_res^.next:=nil;
   bn_res^.prev:=nil;
   bn_res^.tokken_num:=0;

   bn_res_start:=bn_res;
   bn_res_end:=bn_res_start;


   zaem_m:=0; zaem_a:=0;

   while (bn2 <> nil) do begin
         num_n2:=bn2^.tokken_num;

         bn1_t:=bn1;
         bn_res_t:=bn_res;

         while (bn1_t <> nil) do begin
               n1:=(num_n2 * bn1_t^.tokken_num) + zaem_m;
               zaem_m:=n1 div Num_in_tokken_val;

               n2:=(bn_res_t^.tokken_num + (n1 mod Num_in_tokken_val)) + zaem_a;
               zaem_a:=n2 div Num_in_tokken_val;

               bn_res_t^.tokken_num:=n2 mod Num_in_tokken_val;
               if (bn_res_t^.next = nil) then begin
                   new(bn_res_t^.next);
                   bn_res_t^.next^.next:=nil;
                   bn_res_t^.next^.prev:=bn_res_t;
                   bn_res_t^.next^.tokken_num:=0;
                   bn_res_end:=bn_res_t;
               end;

               bn_res_t:=bn_res_t^.next;
               bn1_t:=bn1_t^.next;
         end;
         {ᬮਬ,  ⠫   㬭}
         while (zaem_m > 0) do begin
               n1:=bn_res_t^.tokken_num+zaem_m;
               bn_res_t^.tokken_num:=n1 mod Num_in_tokken_val;
               zaem_m:=n1 div Num_in_tokken_val;
               if (bn_res_t^.next = nil) then begin
                   new(bn_res_t^.next);
                   bn_res_t^.next^.next:=nil;
                   bn_res_t^.next^.prev:=bn_res_t;
                   bn_res_t^.next^.tokken_num:=0;
                   bn_res_end:=bn_res_t;
               end;
               bn_res_t:=bn_res_t^.next;
         end;

         bn2:=bn2^.next;
         bn_res:=bn_res^.next;
   end;
   {஢ਬ,  ⠫    ᫮}
   bn_res:=bn_res_end;
   bn_t:=bn_res;
   while (zaem_a > 0) do begin
        n1:=bn_res^.tokken_num+zaem_a;
        bn_res^.tokken_num:=n1 mod Num_in_tokken_val;
        zaem_a:=n1 div Num_in_tokken_val;
        if (bn_res^.next = nil) then begin
             new(bn_res^.next);
             bn_res^.next^.next:=nil;
             bn_res^.next^.prev:=bn_res;
             bn_res^.next^.tokken_num:=0;
        end;
        bn_t:=bn_res;
        bn_res:=bn_res^.next;
    end;

    {६  }
    if ((bn_t^.next <> nil) and (bn_t^.next^.tokken_num = 0)) then begin
       dispose(bn_t^.next);
       bn_t^.next:=nil;
    end;
    bnMull:=bn_res_start;
end;

{
   2-  ᥫ
}
function bnAdd(bn1, bn2: PBigNumber): PBigNumber;
var
   bn_res, bn_res_start, bn_res_end: PBigNumber;
   num_n2, num_n1, zaem_a: TTokkenNum;
   n1: longint;
begin
   new(bn_res);
   bn_res^.next:=nil;
   bn_res^.prev:=nil;
   bn_res^.tokken_num:=0;

   bn_res_start:=bn_res;
   bn_res_end:=bn_res_start;

   zaem_a:=0;

   while ((bn1 <> nil) or (bn2 <> nil)) do begin
        if (bn1 <> nil) then num_n1:=bn1^.tokken_num else num_n1:=0;
        if (bn2 <> nil) then num_n2:=bn2^.tokken_num else num_n2:=0;

        n1:=num_n1+num_n2+zaem_a;
        bn_res^.tokken_num:=n1 mod Num_in_tokken_val;
        zaem_a:=n1 div Num_in_tokken_val;
        if (bn_res^.next = nil) then begin
             new(bn_res^.next);
             bn_res^.next^.next:=nil;
             bn_res^.next^.prev:=bn_res;
             bn_res^.next^.tokken_num:=0;
             bn_res_end:=bn_res;
        end;
        if (bn1 <> nil) then bn1:=bn1^.next;
        if (bn2 <> nil) then bn2:=bn2^.next;
        bn_res:=bn_res^.next;
   end;
   {஢ਬ,  ⠫    ᫮}
{   bn_res:=bn_res_end;}
   while (zaem_a > 0) do begin
        n1:=bn_res^.tokken_num+zaem_a;
        bn_res^.tokken_num:=n1 mod Num_in_tokken_val;
        zaem_a:=n1 div Num_in_tokken_val;
        if (bn_res^.next = nil) then begin
             new(bn_res^.next);
             bn_res^.next^.next:=nil;
             bn_res^.next^.prev:=bn_res;
             bn_res^.next^.tokken_num:=0;
             bn_res_end:=bn_res;
        end;
        bn_res:=bn_res^.next;
    end;

    {६  }
    if ((bn_res_end^.next <> nil) and (bn_res_end^.next^.tokken_num = 0)) then begin
       dispose(bn_res_end^.next);
       bn_res_end^.next:=nil;
    end;
    bnAdd:=bn_res_start;
end;

{
  頥 val ^ num
}
function bnPow(val: PBigNumber; num: longint): PBigNumber;
var
   i: longint;
   Res1, Res2: PBigNumber;
begin
   Res1:=bnBuild('1');
   for i:=1 to num do begin
       Res2:=bnMull(Res1, val);
       bnDestroy(Res1);
       Res1:=Res2;
   end;
   bnPow:=Res1;
end;


{
  頥 val! (䠪ਠ)
}
function bnFact(num: longint): PBigNumber;
var
   i: longint;
   Res1, Res2: PBigNumber;
begin
   Res1:=bnBuild('1');
   for i:=1 to num do begin
       Res2:=bnMull(Res1, bnBuild(int2str(i)));
       bnDestroy(Res1);
       Res1:=Res2;
   end;
   bnFact:=Res1;
end;

var
   i, j: integer;
   s_time, e_time: longint;
   Res1, Res2, Result1, Result2: PBigNumber;
begin

   writeln;
   writeln('2^200 = ', bnGetPChar(bnPow(bnBuild('2'), 200)));
   {2^200}
{   s_time:=clock;
   for i:=1 to 256 do
      writeln(bnGetPChar(bnPow(bnBuild('2'), i)));
   e_time:=clock;
   writeln;
   writeln(e_time-s_time);}
{   writeln(bnGetPChar(bnFact(2000)));}

{   for i:=1 to 58 do
       writeln(bnGetPChar(bnFact(i)));}
{   writeln(bnGet(bnMull(BigNumber1, BigNumber1)));}
{   writeln();}

{

!1+!2+!3+...+!100
}

s_time:=clock;

{for J:=1 to 20 do
begin}
     Res1:=bnBuild('1');
     Result1:=bnBuild('0');
     for i:=1 to 100 do begin
         Res2:=bnMull(Res1, bnBuild(int2str(i)));
         bnDestroy(Res1);
         Res1:=Res2;

         Result2:=bnAdd(Result1, Res1);
         bnDestroy(Result1);
         Result1:=Result2;
     end;
{end;

e_time:=clock;
}
writeln('!1+!2...+!100 = ', bnGetPChar(Result1));
writeln('!100 = ', bnGetPChar(bnFact(100)));
{writeln('६ ࠡ (ms): ', (e_time-s_time)/20:9:2);}

end.